<?php
/*
Plugin Name: geofilter
Plugin URI: http://schipplock.de
Description: Filter posts regarding client's language
Author: Andreas Schipplock
Version: 1.0
Author URI: http://schipplock.de
*/
/*  Copyright 2008  Andreas Schipplock  (email : andreas@schipplock.de)
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License Version 2, June 1991 as published by
**  the Free Software Foundation
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
require_once(dirname(__FILE__).'/../../../wp-config.php');
require_once(dirname(__FILE__).'/../../../wp-admin/upgrade-functions.php');

require_once(dirname(__FILE__).'/as_geofilter_geoip.inc');
$gi = as_geofilter_geoip_open(dirname(__FILE__)."/as_geofilter_GeoIP.dat",GEOIP_STANDARD);
$ip = $_SERVER['REMOTE_ADDR'];
$countrycode = strtolower(as_geofilter_geoip_country_code_by_addr($gi, $ip));
as_geofilter_geoip_close($gi);

class Geofilter {
	
	function Geofilter() {
		if (isset($this)) {
			# ACTIONS
			add_action('admin_menu', array(&$this, 'as_geofilter_admin'));
			add_action('activate_geofilter/geofilter.php', array(&$this, 'as_geofilter_setup'));
			add_action('wp_footer', array(&$this, 'as_geofilter_footer'));
			# FILTER
			add_filter('the_posts', array(&$this, 'as_geofilter_influence_posts'));
			add_filter('get_pages', array(&$this, 'as_geofilter_influence_posts'));
		}
	}
	
	function as_geofilter_setup() {
		global $wpdb;
		
		if (get_option("as_geofilter_db_version")=="") {
			add_option("as_geofilter_db_version", "1.0");
		} else {
			update_option("as_geofilter_db_version", "1.0");
		}

		$table_name = $wpdb->prefix . "geofilter";

		if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
			$sql = "CREATE TABLE ".$table_name." (
						id bigint not null auto_increment,
						countrycode varchar(10) not null,
						language varchar(10) not null,
						unique key id (id),
						unique key countrycode (countrycode)
					);";
			dbDelta($sql);
			
			//adding initial data
			$insert = "INSERT INTO " . $table_name .
			            " (countrycode,language) " .
			            "VALUES ('en','en');";
			$wpdb->query( $insert );
			$insert = "INSERT INTO " . $table_name .
			            " (countrycode,language) " .
			            "VALUES ('de','de');";
			$wpdb->query( $insert );
			$insert = "INSERT INTO " . $table_name .
			            " (countrycode,language) " .
			            "VALUES ('cn','en');";
			$wpdb->query( $insert );
			$insert = "INSERT INTO " . $table_name .
			            " (countrycode,language) " .
			            "VALUES ('FALLBACK','en');";
			$wpdb->query( $insert );
		}
	}
	
	function as_geofilter_admin() {
		add_options_page('Geofilter', 'Geofilter', 8, 'geofilter-options', array(&$this,'as_geofilter_options'));
	}
	
	function as_geofilter_options() {
		global $wpdb;
		$table_name = $wpdb->prefix . "geofilter";
		
		# if a deletion was requested
		if ($_GET["action"] == "delete") {
			if (is_numeric($_GET["id"])==true) {
				$sql = "delete from ".$table_name." where id = ".$_GET["id"].";";
				$res = mysql_query($sql) or die("dberr");
				$message = "Your countrycode entry has been successfully deleted.";
				require(dirname(__FILE__)."/templates/message.html");
			}
		}
		
		if ($_POST["doSave"]=="true") {
			$db_countrycode = $wpdb->escape($_POST["countrycode"]);
			$db_language = $wpdb->escape($_POST["language"]);
			$sql = "insert into $table_name (countrycode, language) values ('$db_countrycode','$db_language');";
			$wpdb->query($sql);
			$message = "Your countrycode entry has been successfully added.";
			require(dirname(__FILE__)."/templates/message.html");
		}
		
		$res = mysql_query("select id, countrycode, language from $table_name order by id asc;") or die("dberr on select");
		$tableData = array();
		while (list($id,$countrycode,$language)=mysql_fetch_array($res)) {
			array_push($tableData, array(id=>$id,countrycode=>$countrycode,language=>$language));
		}
		
		require_once(dirname(__FILE__)."/templates/options.html");
	}
	
	function as_geofilter_influence_posts($posts) {
		global $countrycode;
		global $wpdb;
		global $wp_query;
	
		$table_name = $wpdb->prefix . "geofilter";
		
		#var_dump($wp_query->query_vars);
		
		$overridecountrycode = $wpdb->escape($_GET["countrycode"]);
		if ($overridecountrycode != "") {
			$countrycode = $overridecountrycode;
		}
		
		# get fallback language in case no countrycode matches
		$res = mysql_query("select language from $table_name where countrycode='FALLBACK' limit 1;");
		list($fallback_language)=mysql_fetch_array($res);
		
		# is countrycode in db?
		$res = mysql_query("select language from $table_name where countrycode='$countrycode';");
		$count = count(mysql_fetch_array($res));
		
		# we need that to know if we are in the adminpanel/backend
		# or in the blog / frontend
		$arSplit = split("/", $_SERVER["SCRIPT_FILENAME"]);
		$filename = $arSplit[count($arSplit)-1];
		
		$entries = array();
		for ($run=0;$run<count($posts);$run++) {
			if ($filename != "index.php") {
				# which is anything except the admin panel
				# a place where you don't want language related filtering :)
				$split = split("#", $posts[$run]->{"post_title"});
				$posts[$run]->{"post_title"} = $split[1];
				array_push($entries, $posts[$run]);
			} else {
				# the blog
				if ($wp_query->query_vars["name"] == "") {
					# if $wp_query->query_vars["name"] is EMPTY
					# it means the client is on the frontpage
					# where all posts got listed
					# this is the place where we only want the filtering
					# we don't want filtering on single posts
					# because then you can't link a german post to an english based guy
					# even if he is able to read german language
					# he would simply get a 404 which would be bad
					$split = split("#", $posts[$run]->{"post_title"});
					$posts[$run]->{"post_title"} = $split[1];
					# count < 2 means the detected language is not defined in your settings
					# so we are using the fallback language which is "FALLBACK" in the database
					# default fallback is "en"
					if ($count < 2) {
						# split[0] contains the countrycode you define in your post's title
						# like en#my wonderful title
						# so display all posts with countrycode of $fallback_language
						# if fallback_language is "en" all posts with en#.. will be displayed
						# easy, eh? but confusing!?!? :P
						if ($split[0] == $fallback_language) {
							array_push($entries, $posts[$run]);
						}
					} else {
						# countrycode IS define in the database
						$res = mysql_query("select countrycode,language from $table_name where countrycode='$countrycode' order by id desc limit 1;") or die("dberr on query");
						list($db_countrycode,$db_language)=mysql_fetch_array($res);
						if ($split[0] == $db_countrycode) {
							# hurray, the detected countrycode is defined in your settings
							# and you attached a language code to it (like "en")
							# countrycode -> language
							array_push($entries, $posts[$run]);
						}	
					}
				} else {
					# if $wp_query->query_vars["name"] is NOT empty it means we are on a single post page
					# here we don't want any filtering, so we just push the requested post :)
					# even if client's detected countrycode is "ar" you can link him an
					# english post for example
					$split = split("#", $posts[$run]->{"post_title"});
					$posts[$run]->{"post_title"} = $split[1];
					array_push($entries, $posts[$run]);
				}
			}
		}
		
		return $entries;
	}
	
	function as_geofilter_footer() {
		global $countrycode;
		print "\n<!-- Geofilter detected the following countrycode: $countrycode //-->\n";
	}
}

$myGeofilter = new Geofilter();

?>
